%
%  Details regarding the parameters and function beam_model_demo.m
%  can be found in beam_model_demo.m
%

  load input
  load q.dat
 
q = [  0.170305430787277 ;
   0.000005491584351 ;
   0.000018552940108 ;
   0.000313035708860 ;
   0.085015195723609 ;
   0.266035528463031 ;
   0.000000060980044 ];

  model = beam_model_demo(q);
  times = [0:Delta_t:(length(voltage)-1) * Delta_t];
  tmax = max(times);

  h = 1e-16;
  Y_complex = complex(q(3),h); 
  q_complex = q;
  q_complex(3) = Y_complex;
  model_complex = beam_model_demo(q_complex);
  Y_cs = imag(model_complex(:,1))/h;

  N = 12;
  hvals = [5e-1 1e-1 5e-2 1e-2 5e-3 1e-3 5e-4 1e-4 5e-5 1e-5 5e-6 1e-6];
  for j=1:N
    h = hvals(j);
    Y_pert = q(1)+h;
    q_pert = q;
    q_pert(1) = Y_pert;
    model_pert = beam_model_demo(q_pert);
    Y_fd = (model_pert - model)/h;  
    rel_err(j) = max(abs(Y_fd-Y_cs))/max(abs(Y_cs));
  end
  h = 5e-4;
  h = 1e-1;
  Y_pert = q(1)+h;
  q_pert = q;
  q_pert(1) = Y_pert;
  model_pert = beam_model_demo(q_pert);
  Y_fd = (model_pert - model)/h;
  
  figure(1)
  plot(times,displace,'--r',times,model,'-b','linewidth',2)
  set(gca,'Fontsize',[22]);
  axis([0 tmax -1e-4 1e-4]);
  hold on
  plot([0 tmax],[0 0],'k-')
  hold off
  xlabel('Time (s)')
  ylabel('Displacement (m)')
  legend('Data','Model','Location','SouthEast')   

  figure(2)
  plot(times,Y_cs,'linewidth',2)
  set(gca,'Fontsize',[22]);
  axis([0 tmax -8e-4 8e-4]);
  hold on
  plot([0 tmax],[0 0],'k-')
  hold off
  xlabel('Time (s)')
  ylabel('w_\gamma')

  figure(3)
  plot(times,Y_fd,'b-','linewidth',2)
  set(gca,'Fontsize',[22]);
%  axis([0 tmax -0.015 0.015]);
  hold on
  plot([0 tmax],[0 0],'k-')
  hold off
  xlabel('Time (s)')
  ylabel('w_{YI_b}')

  figure(4)
  plot(times,Y_cs-Y_fd,'-b','linewidth',2)
  set(gca,'Fontsize',[22]);
  axis([0 tmax -0.015 0.015]);
  hold on
  plot([0 tmax],[0 0],'k-')
  hold off
  xlabel('Time (s)')
  ylabel('Sensitivity')

  figure(5)
  loglog(hvals,rel_err,'x','linewidth',3)
  set(gca,'xdir','reverse');
%  axis([hvals(12),hvals(1),1e-1 1e2]);
  set(gca,'Fontsize',[22]);
  xlabel('Finite-Difference Stepsize (h)')
  ylabel('Relative Error')

  figure(6)
  plot(times,Y_fd,'--r',times,Y_cs,'-b','linewidth',2)
  set(gca,'Fontsize',[22]);
  axis([0 tmax -0.015 0.015]);
  hold on
  plot([0 tmax],[0 0],'k-')
  hold off
  xlabel('Time (s)')
  ylabel('w_{YI_b}')
  legend('Finite-Difference','Complex-Step','Location','NorthWest')


